#ifdef MCF5307
  #error "You can only run siminfo on a MCF5206"
#endif

#include <stdio.h>
#include "sim5206.h"

int main()
{
  SIM5206 *sim;
  int     index;

  iprintf("System Integration Module Info Program\n");
  iprintf("Copyright (c) 1997 - David J. Fiddes\n\n");

  sim = (SIM5206 *)0x10000000;

  iprintf("Set sim pointer: sim =%#X\n\n",sim);

  iprintf("Module: SIM - System Integration Module Configuration\n");
  iprintf("  SIMR:   %.2X\n",sim->simr);
  iprintf("  ICR1:   %.2X\n",sim->icr1);
  iprintf("  ICR2:   %.2X\n",sim->icr2);
  iprintf("  ICR3:   %.2X\n",sim->icr3);
  iprintf("  ICR4:   %.2X\n",sim->icr4);
  iprintf("  ICR5:   %.2X\n",sim->icr5);
  iprintf("  ICR6:   %.2X\n",sim->icr6);
  iprintf("  ICR7:   %.2X\n",sim->icr7);
  iprintf("  ICR8:   %.2X\n",sim->icr8);
  iprintf("  ICR9:   %.2X\n",sim->icr9);
  iprintf("  ICR10:  %.2X\n",sim->icr10);
  iprintf("  ICR11:  %.2X\n",sim->icr11);
  iprintf("  ICR12:  %.2X\n",sim->icr12);
  iprintf("  ICR13:  %.2X\n",sim->icr13);
  iprintf("  IMR:    %.4X\n",sim->imr);
  iprintf("  IPR:    %.4X\n",sim->ipr);
  iprintf("  RSR:    %.2X\n",sim->rsr);
  iprintf("  SYPCR:  %.2X\n",sim->sypcr);
  iprintf("  SWIVR:  %.2X\n",sim->swivr);
  iprintf("  SWSR:   %.2X\n",sim->swsr);
  iprintf("  PAR:    %.2X\n",sim->par);

  iprintf("\n");

  iprintf("Module: DRAMC - DRAM controller configuration\n");
  iprintf("  DCRR:   %.4X\n",sim->dcrr);
  iprintf("  DCTR:   %.4X\n",sim->dctr);
  iprintf("  DCAR0:  %.4X\n",sim->dcar0);
  iprintf("  DCMR0:  %.8X\n",sim->dcmr0);
  iprintf("  DCCR0:  %.2X\n",sim->dccr0);
  iprintf("  DCAR1:  %.4X\n",sim->dcar1);
  iprintf("  DCMR1:  %.8X\n",sim->dcmr1);
  iprintf("  DCCR1:  %.2X\n",sim->dccr1);

  iprintf("\n");

  iprintf("Module: CS - Chip Select configuration\n");
  for(index=0; (index<8); index++)
  {
    iprintf("  CSAR%d:  %.4X\n",index,sim->cs[index].csar);
    iprintf("  CSMR%d:  %.8X\n",index,sim->cs[index].csmr);
    iprintf("  CSCR%d:  %.4X\n",index,sim->cs[index].cscr);
  }
  iprintf("  DMCR:   %.4X\n",sim->dmcr);

  iprintf("\n");

  iprintf("Module: GPIO - General Purpose IO\n");
  iprintf("  PPDDR:  %.2X\n",sim->ppddr);
  iprintf("  PPDAT:  %.2X\n",sim->ppdat);

  iprintf("\n");

  iprintf("Additional Module Offsets\n");
  iprintf("  timer1 = %#X\n",(int)&sim->timer1);
  iprintf("  timer2 = %#X\n",(int)&sim->timer2);
  iprintf("  uart1  = %#X\n",(int)&sim->uart1);
  iprintf("  uart2  = %#X\n",(int)&sim->uart2);
  iprintf("  mbus   = %#X\n",(int)&sim->mbus);
                      
  iprintf("\n\nThe End.\n");
  return 0;
}
